/*
 * main.c
 *
 *  Created on: 2012.11.12.
 *      Author: MaSTeRFoXX
 */

#include <stm32f0xx_conf.h>


void delay(void)
{
	volatile uint32_t i=0;

	for(i=0; i<100000; i++)
	{
	}
}


void hwinit(void)
{
	GPIO_InitTypeDef GPIO_initstruct;

	RCC_AHBPeriphClockCmd(RCC_AHBENR_GPIOCEN,ENABLE);

	GPIO_initstruct.GPIO_Pin=GPIO_Pin_8;
	GPIO_initstruct.GPIO_PuPd=GPIO_PuPd_NOPULL;
	GPIO_initstruct.GPIO_OType=GPIO_OType_PP;
	GPIO_initstruct.GPIO_Mode=GPIO_Mode_OUT;
	GPIO_initstruct.GPIO_Speed=GPIO_Speed_50MHz;

	GPIO_Init(GPIOC,&GPIO_initstruct);

}

void PWM_init(void)
{
	GPIO_InitTypeDef GPIO_initstruct;
	TIM_TimeBaseInitTypeDef  TIM_timebase;
	TIM_OCInitTypeDef  TIM_OCInitStructure;

	//rajel ads a timernak ->adatlap hogy melyik buszon van!!!
	RCC_APB1PeriphClockCmd(RCC_APB1ENR_TIM3EN,ENABLE);

	//bekonfigurlni hogy a PC9 lb alternatv funkciban mkdjn
	GPIO_initstruct.GPIO_Pin=GPIO_Pin_9;
	GPIO_initstruct.GPIO_PuPd=GPIO_PuPd_NOPULL; //fel/lehzs
	GPIO_initstruct.GPIO_OType=GPIO_OType_PP; //puspull
	GPIO_initstruct.GPIO_Mode=GPIO_Mode_AF; //alternatv funkci -> CSAK 1db van
	GPIO_initstruct.GPIO_Speed=GPIO_Speed_50MHz;
	GPIO_Init(GPIOC,&GPIO_initstruct);

	TIM_timebase.TIM_Prescaler=4800;   //48MHz/4800/periodus=100Hz
	TIM_timebase.TIM_Period=100; //A peridus=100
	TIM_timebase.TIM_CounterMode=TIM_CounterMode_Up; //felfele szmol
	TIM_timebase.TIM_ClockDivision=0; //ez nincs a TIM3ban
	TIM_timebase.TIM_RepetitionCounter=0; //ez nincs a TIM3ban

	TIM_TimeBaseInit(TIM3,&TIM_timebase); //Idalap bekonfolsa

	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2;
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low;
	TIM_OCInitStructure.TIM_OCIdleState = TIM_OCIdleState_Set;

	TIM_OCInitStructure.TIM_Pulse = 50; //kitltsi tnyez

	TIM_OC4Init(TIM3,&TIM_OCInitStructure);

	TIM_Cmd(TIM3,ENABLE); //timer be
	TIM_CtrlPWMOutputs(TIM3,ENABLE); //kimenetek be
}

int main(void)
{
	hwinit();
	PWM_init();

	uint8_t i=0;
	while(1)
	{
		GPIO_SetBits(GPIOC,GPIO_Pin_8);
		delay();
		GPIO_ResetBits(GPIOC,GPIO_Pin_8);

		i+=2;
		if(i>100) i=0;
		TIM3->CCR4=i; //kitltsi tnyez rsa kzvetlen
		delay();
	}

}
